import ExtendableError from 'es6-error';
export declare class PlantonError extends ExtendableError {
}
export declare class UnexpectedStateError extends PlantonError {
    code: string;
    constructor(message: string, code?: string);
}
export declare class InvalidTaskConfigurationNameError extends UnexpectedStateError {
    taskName: string;
    constructor(taskName: string, message: string);
}
export declare class DuplicateTaskNameError extends UnexpectedStateError {
    duplicateTaskName: string;
    constructor(duplicateTaskName: string);
}
export declare class UnexpectedTaskInstructionsError extends UnexpectedStateError {
    taskName: string;
    unexpectedTaskInstructions: string[];
    constructor(taskName: string, unexpectedTaskInstructions: string[]);
}
