"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnexpectedTaskInstructionsError = exports.DuplicateTaskNameError = exports.InvalidTaskConfigurationNameError = exports.UnexpectedStateError = exports.PlantonError = void 0;
const es6_error_1 = __importDefault(require("es6-error"));
class PlantonError extends es6_error_1.default {
}
exports.PlantonError = PlantonError;
class UnexpectedStateError extends PlantonError {
    constructor(message, code = 'UNEXPECTED_STATE_ERROR') {
        super(message);
        this.code = code;
    }
}
exports.UnexpectedStateError = UnexpectedStateError;
class InvalidTaskConfigurationNameError extends UnexpectedStateError {
    constructor(taskName, message) {
        super(message, 'INVALID_TASK_CONFIGURATION');
        this.taskName = taskName;
    }
}
exports.InvalidTaskConfigurationNameError = InvalidTaskConfigurationNameError;
class DuplicateTaskNameError extends UnexpectedStateError {
    constructor(duplicateTaskName) {
        super('Task name is duplicate.', 'DUPLICATE_TASK_NAME');
        this.duplicateTaskName = duplicateTaskName;
    }
}
exports.DuplicateTaskNameError = DuplicateTaskNameError;
class UnexpectedTaskInstructionsError extends UnexpectedStateError {
    constructor(taskName, unexpectedTaskInstructions) {
        super('Unexpected task instructions.', 'UNEXPECTED_TASK_INSTRUCTIONS');
        this.taskName = taskName;
        this.unexpectedTaskInstructions = unexpectedTaskInstructions;
    }
}
exports.UnexpectedTaskInstructionsError = UnexpectedTaskInstructionsError;
